#include	<windows.h>
#include	<commctrl.h>
#include	<stdio.h>

#define FILENAMESIZE	512
#define OPEN_FILE		TRUE
#define SAVE_FILE		FALSE

typedef	struct{
		double	x;
		double	y;
		double	z;
		} SDATA;

/* t@CJ/ۑ邽߂̃_CAO̕\ */
/* t@C̃tpXԂ */
/* ԂlFTRUE = OK button / FALSE = other */
int	commonFileDlg( char fullPathName[], int action ){
	OPENFILENAME	ofn;
	int	result;

/*	lstrcpy(FullPathName,"");	*/
	memset( &ofn, '\0', sizeof( OPENFILENAME ) );
	ofn.lStructSize = sizeof( OPENFILENAME );
//	ofn.hDlgOwner = NULL;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = fullPathName;
	ofn.nMaxFile = FILENAMESIZE;
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	ofn.lpstrFilter = "CSV(*.csv)\0*.csv\0";
	ofn.lpstrDefExt = "csv";

	if( action == OPEN_FILE ){
		ofn.lpstrTitle = "t@CJ";
		result = GetOpenFileName( &ofn );	/* TRUE=OK_button FALSE=other */
	}else{
		ofn.lpstrTitle = "t@C̕ۑ";
		result =GetSaveFileName( &ofn );	/* TRUE=OK_button FALSE=other */
	}

	return ( result );	/* TRUE = OK_button : FALSE = other */
}

/* Iz̃̊mۗpɍs𐔂 */
int	countCR( FILE *fp ){
	int c, num=0;

	while( ( c = getc( fp ) ) != EOF )
		if( c == '\n' )
			num++;
	rewind( fp );
	return( num );
}

/* \[gpr֐ Y */
int	sdata_cmp( const void* a, const void* b ){
	SDATA	d1 = *(SDATA*)a;
	SDATA	d2 = *(SDATA*)b;

	if( d1.y - d2.y < 0 )	return( -1 );
	if( d1.y - d2.y > 0 )	return( 1 );
	if( d1.x - d2.x < 0 )	return( -1 );
	if( d1.x - d2.x > 0 )	return( 1 );
	if( d1.z - d2.z < 0 )	return( -1 );
	if( d1.z - d2.z > 0 )	return( 1 );
	return( 0 );
}

/* X,Y,Z`CSVt@Cǂݍ */
int	readCsv( FILE *fp, SDATA *sdata ){
	char	s[64]="", c1[2]="0";
	int		c, i=0;

	while( ( c = fgetc( fp ) ) !=EOF ){
		if( c == ',' || c == '\n' ){
			switch( i % 3 ){
				case 0:
					sdata[ i / 3 ].x = strtod( s, NULL );
					break;
				case 1:
					sdata[ i / 3 ].y = strtod( s, NULL );
					break;
				case 2:
					sdata[ i / 3 ].z = strtod( s, NULL );
					break;
			}
			i++;
			strcpy( s, "" );
		}else if( isdigit( c ) || c == '+' || c == '-' || c == '.' ){
				c1[0] = (char)c;
				strcat( s, c1 );
		}
	}
	return( i / 3 );
}

/* X cY \Z ɕϊf[^t@Cɏ */
void	saveCsv( FILE *fp, SDATA *sdata, int count ){
	int	i, j;
	double	oldData = sdata[0].y;

	/* 1s */
	fputs( "XYZ", fp );
	for( i = 0; oldData == sdata[ i ].y; i++ ){
		fprintf( fp, ",%f", sdata[i].x );
		oldData = sdata[i].y;
	}
	oldData = sdata[i].y;

	/* 2sڈȌ */
	for( i = 0; i < count; i++){
		if( oldData != sdata[ i ].y ){
			fprintf( fp, "\n%f", sdata[i].y );
			oldData = sdata[i].y;
		}
		fprintf( fp, ",%f", sdata[ i ].z );
	}
}

/* Drag&DropL ۑt@C쐬 */
int	dragDrop( char *saveF, char *dropF ){
	char	*tmpF;

	if( ( tmpF = tmpnam( NULL ) ) == NULL )	return( TRUE );	/* tmp file error */
	strcpy( saveF, dropF );
	saveF[ strrchr( saveF, '\\' ) - saveF + 1 ] = '\0';
	strcat( saveF, tmpF );
	saveF[ strrchr( saveF, '.' ) - saveF ] = '\0';
	strcat( saveF, ".csv" );
	return( FALSE );
}

//int	main( void ){
int	WINAPI	WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, LPSTR lpsCmdLine, int nCmdShow) {
	FILE	*srcFp, *saveFp;
	char	readPathName[512]="", savePathName[512]="";
	int		crNum, xNum;
	SDATA	*sdata;

	if( strlen( lpsCmdLine ) == 0 ){
		/* Drag&Drop */
		if( !commonFileDlg( readPathName, OPEN_FILE ) ){
			MessageBox( NULL, "t@CI܂ł", "Error", MB_OK );
			return( TRUE );
		}
	} else {
		/* Drag&DropL */
		strcpy( readPathName, lpsCmdLine );
	}
	if( ( srcFp = fopen( readPathName, "r" ) ) == NULL ){
		MessageBox( NULL, "Ǎt@CG[", "Error", MB_OK );
		return( TRUE );
	}

	if( strlen( lpsCmdLine ) == 0 ){
		/* Drag&Drop */
		if( !commonFileDlg( savePathName, SAVE_FILE ) ){
			MessageBox( NULL, "t@CI܂ł", "Error", MB_OK );
			return( TRUE );
		}
	} else {
		/* Drag&DropL */
		if( dragDrop( savePathName, lpsCmdLine ) )	return( TRUE );
	}
	if( ( saveFp = fopen( savePathName, "w" ) ) == NULL ){
		MessageBox( NULL, "ۑt@CG[", "Error", MB_OK );
		return( TRUE );
	}

	/* Iz̃̊mۗpɍs𐔂 */
	crNum = countCR( srcFp );
	sdata = (SDATA*)calloc( crNum * 3, sizeof(SDATA) );

	/* X,Y,Z`CSVt@Cǂݍ */
	xNum = readCsv( srcFp, sdata );

	/* \[g Y */
	qsort( sdata, xNum, sizeof( SDATA ), sdata_cmp );

	/* X cY \Z ɕϊf[^t@Cɏ */
	saveCsv( saveFp, sdata, xNum );

	fclose( srcFp );
	fclose( saveFp );
	free( sdata );

	/* ϊt@C"csv2dx23.exe"ɓn */
	if( strlen( lpsCmdLine ) )
		if( (LONG)ShellExecute(NULL, NULL, "csv2dx23.exe", savePathName, NULL, SW_SHOWNORMAL) < 32 )
			MessageBox( NULL, "csv2dx23.exe ܂ł", "Error", MB_OK );
	return( FALSE );
}
