#include	<windows.h>
#include	<commctrl.h>
#include	<stdio.h>
#include	<string.h>
#include	"csv2dx23.h"

/*--- _CAOѕ`̈̏ݒ ---*/
void	initForm( HWND hDlg ){
	RECT	rect;

	SetWindowText( GetDlgItem( hDlg, IDC_LBL_VER ), VER_TXT );
	gCsvNotOpen = TRUE;		/* TRUE = csv file not open : FALSE = csv file opened */

	/* `̈̐ݒ */
	GetClientRect( GetDlgItem( hDlg, IDC_TPANEL0 ), &rect );
	ox = rect.right + 1;		/* EChE̕`̈@ŏX */
	py = rect.bottom - 1;		/* `̈̍ */
	GetClientRect( hDlg, &rect );
	px = rect.right - ox - 1;		/* `̈̕ */

	/* WI{^l */
	SendDlgItemMessage( hDlg, IDC_RADIO_3D, BM_SETCHECK, BST_CHECKED, 0 );
	SendDlgItemMessage( hDlg, IDC_RADIO_FACE, BM_SETCHECK, BST_CHECKED, 0 );
}

/* methodWIO[v̕\/\ */
void	dimRadioClick( HWND hDlg ){
	int	visible;

	visible = ( SendDlgItemMessage( hDlg, IDC_RADIO_2D, BM_GETCHECK, 0, 0 ) ? SW_HIDE : SW_SHOW );
	ShowWindow( GetDlgItem( hDlg, IDC_GROUPBOX2 ), visible );
	ShowWindow( GetDlgItem( hDlg, IDC_RADIO_LINE ), visible );
	ShowWindow( GetDlgItem( hDlg, IDC_RADIO_MESH ), visible );
	ShowWindow( GetDlgItem( hDlg, IDC_RADIO_FACE ), visible );

	/* WI{^NbNꂽĕ`悵Ȃ */
	gCsvNotOpen = TRUE;	/* TRUE = csv not open : FALSE = csv opened */
}

/* t@CJ/ۑ邽߂̃_CAO̕\ */
/* t@C̃tpXԂ */
/* ԂlFTRUE = OK button / FALSE = other */
int	commonFileDlg( HWND hwnd, char fullPathName[], int action ){
	OPENFILENAME	ofn;
	int	result;

/*	lstrcpy(FullPathName,"");	*/
	memset( &ofn, '\0', sizeof( OPENFILENAME ) );
	ofn.lStructSize = sizeof( OPENFILENAME );
	ofn.hwndOwner = hwnd;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = fullPathName;
	ofn.nMaxFile = FILENAMESIZE;
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;

	if( action == OPEN_FILE ){
		ofn.lpstrFilter = "CSV(*.csv)\0*.csv\0";
		ofn.lpstrDefExt = "csv";
		ofn.lpstrTitle = "t@CJ";
		result = GetOpenFileName( &ofn );	/* TRUE=OK_button FALSE=other */
	}else{
		ofn.lpstrFilter = "DXF(*.dxf)\0*.dxf\0";
		ofn.lpstrDefExt = "dxf";
		ofn.lpstrTitle = "t@C̕ۑ";
		result =GetSaveFileName( &ofn );	/* TRUE=OK_button FALSE=other */
	}

	return ( result );	/* TRUE = OK_button : FALSE = other */
}

/* 2D Xŏő Yŏő ̃Zbg */
void	cmp_minmax_2D( int d, int e ){
	if( e != 0 ){
		if( d != 0 ){
			if( ymin > data[d][e] )	ymin = data[d][e];
			if( ymax < data[d][e] )	ymax = data[d][e];
		}else{
			if( xmin > data[d][e] )	xmin = data[d][e];
			if( xmax < data[d][e] )	xmax = data[d][e];
		}
	}else{
		if( d != 0 )	ymin = ymax = data[d][e];
		else	xmin = xmax = data[d][e];
	}
}

/* 2Dt@C̓ǂݍ */
void	read_2D( FILE *handle ){
	char	st[512]="", ch[2]="0";
	int 	c, d, e;

	d = e = 0;
	while( ( c = fgetc( handle ) ) != EOF ){
		if( c == '\n' ){
			data[d][e] = strtod( st, NULL );
			cmp_minmax_2D( d, e );
			strcpy( st, "" );
			if( d != 0 )	break;
			mx = e;
			d = 1;
			e = 0;
		}else if( c == ',' ){
			data[d][e] = strtod( st, NULL );
			cmp_minmax_2D( d, e );
			strcpy( st, "" );
			e++;
		}else if( isdigit( c ) || c == '+' || c == '-' || c == '.' ){
			ch[0] = c;
			strcat( st, ch );
		}
	}
}

/* 3D Xŏő Yŏő ̃Zbg */
void	cmp_minmax_3D( int d, int e ){
	double	x, y;
	if( e == 1 && d == 1 ){
		xmin = xmax = 0.866 * ( data[0][e] + data[d][0] );
		ymin = ymax = 0.5   * ( data[d][0] - data[0][e] ) + data[d][e];
	}else if( e != 0 ){
		x = 0.866 * ( data[0][e] + data[d][0] );
		y = 0.5   * ( data[d][0] - data[0][e] ) + data[d][e];
		if( xmin > x )	xmin = x;
		if( xmax < x )	xmax = x;
		if( ymin > y )	ymin = y;
		if( ymax < y )	ymax = y;
	}
}

/* 3Dt@C̓ǂݍ */
void	read_3D( FILE *handle ) {
	char	st[512]="", ch[2]="0";
	int 	c, d, e;

	d = e = 0;
	while( ( c = fgetc( handle ) ) != '\n' ){
		if( c == ',' ){
			data[d][e] = strtod( st, NULL );
			strcpy( st, "" );
			e++;
		}else if( isdigit( c ) || c == '+' || c == '-' || c == '.' ){
			ch[0] = c;
			strcat( st, ch );
		}
	}
	data[d][e] = strtod( st, NULL );
	strcpy( st, "" );
	mx = e;
	d = 1;
	e = 0;
	while( ( c = fgetc( handle ) ) != EOF ){
		if( c == '\n' ){
			data[d][e] = strtod( st, NULL );
			cmp_minmax_3D( d, e );	/* 3D Xŏő Yŏő ̃Zbg */
			strcpy( st, "" );
			my = d;
			d++;
			e = 0;
		}else if( c == ',' ){
			data[d][e] = strtod( st, NULL );
			cmp_minmax_3D( d, e );	/* 3D Xŏő Yŏő ̃Zbg */
			strcpy( st, "" );
			e++;
		}else if( isdigit( c ) || c == '+' || c == '-' || c == '.' ){
			ch[0] = c;
			strcat( st, ch );
		}
	}
}

/* 2DOt̕` */
void	draw_2D( HWND hDlg ){
	int 	i, x, y, qx;
	double	d, dx, dy, s;
	HDC		PaintDC;
	RECT	rect;
	HWND	hCanvas;
	HBRUSH	hBrush;
	PAINTSTRUCT	ps;

	/* `̈̍쐬 */
	GetClientRect( hDlg, &rect );
	hCanvas = CreateWindow( "STATIC", "",
				WS_CHILD|WS_VISIBLE|SS_BLACKFRAME,
				0, 0, rect.right, rect.bottom,
				hDlg, (HMENU)1, NULL, NULL );
	PaintDC=BeginPaint( hCanvas, &ps );

	hBrush=GetStockObject( WHITE_BRUSH );
	SelectObject( PaintDC, hBrush );
	Rectangle( PaintDC, ox, 0, ox+px+1, py+1 );

	/* `̏kڂƌ_vZ */
	dx = xmax - xmin;
	dy = ymax - ymin;
	d = dy / 0.75;

	if( d < dx ){
		s = px / dx;	/* Xk */
		qx = ox;	/* `_ */
	}else{
		s = py / dy;	/* Yk */
		qx = ox + (int)( ( d - dx ) / 2 * s );	/* `_ */
	}
	/* ` */
	x = qx + (int)( ( data[0][0] - xmin ) * s );
	y = py - (int)( ( data[1][0] - ymin ) * s );
	MoveToEx( PaintDC, x,y, NULL );
	for( i = 1; i <= mx; i++ ){
		x = qx + (int)( ( data[0][i] - xmin ) * s );
		y = py - (int)( ( data[1][i] - ymin ) * s );
		LineTo( PaintDC, x,y );
	}

	EndPaint( hCanvas,&ps );
}

/* 3DOt̕` */
void	draw_3D( HWND hDlg ){
	int 	i, j, x, y, qx;
	double	d, dx, dy, s;
	HDC		PaintDC;
	RECT	rect;
	HWND	hCanvas;
	HBRUSH	hBrush;
	PAINTSTRUCT	ps;

	/* `̈̍쐬 */
	GetClientRect( hDlg, &rect );
	hCanvas = CreateWindow( "STATIC","",
				 WS_CHILD|WS_VISIBLE|SS_BLACKFRAME,
				 0,0,rect.right,rect.bottom,
				 hDlg, ( HMENU)1, NULL, NULL );
	PaintDC=BeginPaint( hCanvas,&ps );

	hBrush=GetStockObject( WHITE_BRUSH );
	SelectObject( PaintDC,hBrush );
	Rectangle( PaintDC,ox,0,ox+px+1,py+1 );

	/* `̏kڂƌ_vZ */
	dx = xmax - xmin;
	dy = ymax - ymin;
	d = dy / 0.75;
	if( d < dx ){
		s = px / dx;	/* Xk */
		qx = ox;	/* `_ */
	}else{
		s = py / dy;	/* Yk */
		qx = ox + (int)( ( d - dx ) / 2 * s );	/* `_ */
	}
	/* ` */
	for( i = 1; i <= mx; i++ ){
		x = qx + (int)( ( 0.866 * ( data[0][i] + data[1][0] ) - xmin ) * s );
		y = py - (int)( ( ( 0.5 * ( data[1][0] - data[0][i] ) + data[1][i] ) - ymin ) * s );
		MoveToEx( PaintDC, x,y, NULL );
		for( j = 2; j <= my; j++ ){
			x = qx + (int)( ( 0.866 * ( data[0][i] + data[j][0] ) - xmin ) * s );
			y = py - (int)( ( ( 0.5 * ( data[j][0] - data[0][i] ) + data[j][i] ) - ymin ) * s );
			LineTo( PaintDC, x,y );
		}
	}
	for( j = 1; j <= my; j++ ){
		x = qx + (int)( ( 0.866 * ( data[0][1] + data[j][0] ) - xmin ) * s );
		y = py - (int)( ( ( 0.5 * ( data[j][0] - data[0][1] ) + data[j][1] ) - ymin ) * s );
		MoveToEx( PaintDC, x,y, NULL );
		for( i = 2; i <= mx; i++ ){
			x = qx + (int)( ( 0.866 * ( data[0][i] + data[j][0] ) - xmin ) * s );
			y = py - (int)( ( ( 0.5 * ( data[j][0] - data[0][i] ) + data[j][i] ) - ymin ) * s );
			LineTo( PaintDC, x,y );
		}
	}
	EndPaint( hCanvas,&ps );
}

/* CSVǂݍ݃{^ */
void	btnReadClick( HWND hDlg ){
	FILE	*handle;
	char	*fileName, fullPathName[512]="";


	if( commonFileDlg( NULL, fullPathName, OPEN_FILE ) ){
		fileName = strrchr( fullPathName, '\\' ) + 1;
		SetWindowText( GetDlgItem( hDlg, IDC_LBL_FNAME ), fileName );
		if( ( handle = fopen( fullPathName, "r" ) ) == NULL ){
			perror( "ǍG[" );
		}else{
			if( SendDlgItemMessage( hDlg, IDC_RADIO_2D, BM_GETCHECK, 0, 0 ) ){
				read_2D( handle );
				draw_2D( hDlg );
			}else{														// 3D
				read_3D( handle );
				draw_3D( hDlg );
			}
			fclose( handle );
			gCsvNotOpen = FALSE;	/* csv file open */
		}
		/* DXFt@C̍쐬 */
		strcpy( gSaveFileName, fileName );
		gSaveFileName[ strrchr( gSaveFileName, '.' ) - gSaveFileName ] = '\0';
		strcat( gSaveFileName, ".dxf" );
		SendDlgItemMessage( hDlg, IDC_STATUSBAR, SB_SETTEXT, 0, (LPARAM)( "o" ) );
	}
}

/* Drag&Drop */
void	readDropFile( HWND hDlg ){
	FILE	*handle;
	char	*fileName;

	if( ( handle = fopen( dropFile, "r" ) ) == NULL ){
		perror( "ǍG[" );
	}else{
		read_3D( handle );
		draw_3D( hDlg );
		fclose( handle );
		gCsvNotOpen = FALSE;	/* csv file open */
	}

	/* DXFt@C̍쐬 */
	fileName = strrchr( dropFile, '\\' ) + 1;
	strcpy( gSaveFileName, fileName );
	gSaveFileName[ strrchr( gSaveFileName, '.' ) - gSaveFileName ] = '\0';
	strcat( gSaveFileName, ".dxf" );
	SendDlgItemMessage( hDlg, IDC_STATUSBAR, SB_SETTEXT, 0, (LPARAM)( "o" ) );
}

/* 2D-DXF t@Cۑ */
void	write_2D( FILE *handle ){
	int 	i;
	fprintf( handle, "  0\nPOLYLINE\n" );
	fprintf( handle, "  8\ncsv2dx23\n" );
	fprintf( handle, " 66\n1\n" );
	fprintf( handle, " 70\n0\n" );
	for( i = 0; i <= mx; i++ ){
		fprintf( handle, "  0\nVERTEX\n" );
		fprintf( handle, " 10\n%f\n", data[0][i] );
		fprintf( handle, " 20\n%f\n", data[1][i] );
	}
	fprintf( handle, "  0\nSEQEND\n" );
}

/* 3D-DXF_LINE t@Cۑ */
void	write_3Dline( FILE *handle ){
	int 	i, j;
	for( i = 1; i <= mx; i++ ){
		fprintf( handle, "  0\nPOLYLINE\n" );
		fprintf( handle, "  8\ncsv2dx23\n" );
		fprintf( handle, " 66\n1\n" );
		fprintf( handle, " 70\n8\n" );
		for( j = 1; j <= my; j++ ){
			fprintf( handle, "  0\nVERTEX\n" );
			fprintf( handle, " 10\n%f\n", data[0][i] );
			fprintf( handle, " 20\n%f\n", data[j][0] );
			fprintf( handle, " 30\n%f\n", data[j][i] );
		}
		fprintf( handle, "  0\nSEQEND\n" );
	}
	for( j = 1; j <= my; j++ ){
		fprintf( handle, "  0\nPOLYLINE\n" );
		fprintf( handle, "  8\ncsv2dx23\n" );
		fprintf( handle, " 66\n1\n" );
		fprintf( handle, " 70\n8\n" );
		for( i = 1; i <= mx; i++ ){
			fprintf( handle, "  0\nVERTEX\n" );
			fprintf( handle, " 10\n%f\n", data[0][i] );
			fprintf( handle, " 20\n%f\n", data[j][0] );
			fprintf( handle, " 30\n%f\n", data[j][i] );
		}
		fprintf( handle, "  0\nSEQEND\n" );
	}
}

/* 3D-DXF_MESH t@Cۑ */
void	write_3Dmesh( FILE *handle ){
	int 	i, j;
	for( i = 1; i < mx; i++ ){
		for( j = 1; j < my; j++ ){
			fprintf( handle, "  0\nPOLYLINE\n" );
			fprintf( handle, "  8\ncsv2dx23\n" );
			fprintf( handle, " 66\n1\n" );
			fprintf( handle, " 70\n9\n" );
			fprintf( handle, "  0\nVERTEX\n" );
			fprintf( handle, " 10\n%f\n", data[ 0 ][ i ] );
			fprintf( handle, " 20\n%f\n", data[ j ][ 0 ] );
			fprintf( handle, " 30\n%f\n", data[ j ][ i ] );
			fprintf( handle, "  0\nVERTEX\n" );
			fprintf( handle, " 10\n%f\n", data[ 0 ][i+1] );
			fprintf( handle, " 20\n%f\n", data[ j ][ 0 ] );
			fprintf( handle, " 30\n%f\n", data[ j ][i+1] );
			fprintf( handle, "  0\nVERTEX\n" );
			fprintf( handle, " 10\n%f\n", data[ 0 ][i+1] );
			fprintf( handle, " 20\n%f\n", data[j+1][ 0 ] );
			fprintf( handle, " 30\n%f\n", data[j+1][i+1] );
			fprintf( handle, "  0\nVERTEX\n" );
			fprintf( handle, " 10\n%f\n", data[ 0 ][ i ] );
			fprintf( handle, " 20\n%f\n", data[j+1][ 0 ] );
			fprintf( handle, " 30\n%f\n", data[j+1][ i ] );
			fprintf( handle, "  0\nSEQEND\n" );
		}
	}
}

/* 3D-DXF_FACE t@Cۑ */
void	write_3Dface( FILE *handle ){
	int 	i, j;
	for( i = 1; i < mx; i++ ){
		for( j = 1; j < my; j++ ){
			fprintf( handle, "  0\n3DFACE\n" );
			fprintf( handle, "  8\ncsv2dx23\n" );
			fprintf( handle, " 66\n1\n" );
			fprintf( handle, " 70\n9\n" );
			fprintf( handle, " 10\n%f\n", data[ 0 ][ i ] );
			fprintf( handle, " 20\n%f\n", data[ j ][ 0 ] );
			fprintf( handle, " 30\n%f\n", data[ j ][ i ] );
			fprintf( handle, " 11\n%f\n", data[ 0 ][i+1] );
			fprintf( handle, " 21\n%f\n", data[ j ][ 0 ] );
			fprintf( handle, " 31\n%f\n", data[ j ][i+1] );
			fprintf( handle, " 12\n%f\n", data[ 0 ][i+1] );
			fprintf( handle, " 22\n%f\n", data[j+1][ 0 ] );
			fprintf( handle, " 32\n%f\n", data[j+1][i+1] );
			fprintf( handle, " 13\n%f\n", data[ 0 ][ i ] );
			fprintf( handle, " 23\n%f\n", data[j+1][ 0 ] );
			fprintf( handle, " 33\n%f\n", data[j+1][ i ] );
			fprintf( handle, "  0\nSEQEND\n" );
		}
	}
}

/* ۑ` */
void	write_D( FILE *handle, HWND hDlg ){
	fprintf( handle, "  0\nSECTION\n" );
	fprintf( handle, "  2\nENTITIES\n" );

	if( SendDlgItemMessage( hDlg, IDC_RADIO_2D, BM_GETCHECK, 0, 0 ) )		// 2D
		write_2D( handle );
	else if( SendDlgItemMessage( hDlg, IDC_RADIO_LINE, BM_GETCHECK, 0, 0 ) )		// 3D Line
		write_3Dline( handle );
	else if( SendDlgItemMessage( hDlg, IDC_RADIO_MESH, BM_GETCHECK, 0, 0 ) )		// 3D Mesh
		write_3Dmesh( handle );
	else if( SendDlgItemMessage( hDlg, IDC_RADIO_FACE, BM_GETCHECK, 0, 0 ) )		// 3D Face
		write_3Dface( handle );

	fprintf( handle, "  0\nENDSEC\n" );
	fprintf( handle, "  0\nEOF\n" );
}

/* DXFۑ{^ */
void	btnSaveClick( HWND hDlg ){
	FILE	*handle;
	char fullPathName[512]="";

	if( gCsvNotOpen ) return;		/* csv file		TRUE = not open : FALSE = opened */

	if( commonFileDlg( NULL, fullPathName, SAVE_FILE ) ){
		if( ( handle = fopen( fullPathName, "wt" ) ) == NULL ){
			perror( "݃G[" );
		}else{
			write_D( handle, hDlg );
			fclose( handle );
			SendDlgItemMessage( hDlg, IDC_STATUSBAR, SB_SETTEXT, 0, (LPARAM)( "ۑ" ) );
		}
	}
}

/* _CAO */
BOOL CALLBACK DlgProc( HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam ) {
	char	str[256];

	switch( Msg ){
		case    WM_PAINT:	/* ĕ`揈 */
				if( !gCsvNotOpen )
					if( SendDlgItemMessage( hDlg, IDC_RADIO_2D, BM_GETCHECK, 0, 0 ) )		// 2D
						draw_2D( hDlg );
					else
						draw_3D( hDlg );
				break;

		case	WM_COMMAND:	/* Rg[Cxg */
			switch( LOWORD( wParam ) ){
				case	IDC_BTN_READ:
					btnReadClick( hDlg );
					break;
				case	IDC_BTN_SAVE:
					btnSaveClick( hDlg );
					break;
				case	IDC_BTN_EXIT:
					EndDialog( hDlg, 0 );
					return( TRUE );
				case	IDC_RADIO_2D:
					dimRadioClick( hDlg );
					break;
				case	IDC_RADIO_3D:
					dimRadioClick( hDlg );
					break;
				default:
					break;
			}
			break;

		case	WM_CLOSE:	/* I */
			EndDialog( hDlg, 0 );
			return( TRUE );

		case	WM_INITDIALOG:	/* ݒ */
			initForm( hDlg );
			if( strlen( dropFile ) ) readDropFile( hDlg );
			return( TRUE );
	}

	return( FALSE );
}

//int	main( void ){
int	WINAPI	WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, LPSTR lpsCmdLine, int nCmdShow) {

	strcpy( dropFile, lpsCmdLine );

	DialogBox( NULL, MAKEINTRESOURCE( IDD_FORM1 ), NULL, DlgProc );
	return 0;
}
